<html>
<head>
<title>OgreRenderSystem.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreRenderSystem.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreRenderSystem_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __RenderSystem_H_</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __RenderSystem_H_</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreString_8h.html">OgreString.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreTextureUnitState_8h.html">OgreTextureUnitState.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterialManager_8h.html">OgreMaterialManager.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderOperation_8h.html">OgreRenderOperation.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderSystemCapabilities_8h.html">OgreRenderSystemCapabilities.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderTarget_8h.html">OgreRenderTarget.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderTexture_8h.html">OgreRenderTexture.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="OgreFrameListener_8h.html">OgreFrameListener.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="OgreConfigOptionMap_8h.html">OgreConfigOptionMap.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &quot;<a class="code" href="OgrePlane_8h.html">OgrePlane.h</a>&quot;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;<a class="code" href="OgreIteratorWrappers_8h.html">OgreIteratorWrappers.h</a>&quot;</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">namespace </span>Ogre
<a name="l00051"></a>00051 {
<a name="l00059"></a><a class="code" href="group__RenderSystem.html#gab02aadb96f4799458080219e1885b1ec">00059</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1vector.html#a5e5f8d7fb74dbc2b426c18e1f7b22323">vector&lt;DepthBuffer*&gt;::type</a> <a class="code" href="group__RenderSystem.html#gab02aadb96f4799458080219e1885b1ec">DepthBufferVec</a>;
<a name="l00060"></a><a class="code" href="group__RenderSystem.html#ga6976cd039d94260fb992a6fd1f072133">00060</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt; uint16, DepthBufferVec &gt;::type</a> <a class="code" href="group__RenderSystem.html#ga6976cd039d94260fb992a6fd1f072133">DepthBufferMap</a>;
<a name="l00061"></a><a class="code" href="group__RenderSystem.html#ga0fc2f530f0d042c937e49131cde29245">00061</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt; String, RenderTarget * &gt;::type</a> <a class="code" href="group__RenderSystem.html#ga0fc2f530f0d042c937e49131cde29245">RenderTargetMap</a>;
<a name="l00062"></a><a class="code" href="group__RenderSystem.html#ga49f68547d022aa6d7f10745ea069ebd9">00062</a>     <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1multimap.html">multimap&lt;uchar, RenderTarget * &gt;::type</a> <a class="code" href="group__RenderSystem.html#ga49f68547d022aa6d7f10745ea069ebd9">RenderTargetPriorityMap</a>;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keyword">class </span><a class="code" href="classOgre_1_1TextureManager.html" title="Class for loading &amp; managing textures.">TextureManager</a>;
<a name="l00066"></a><a class="code" href="group__RenderSystem.html#gaa9c06899edc6b7aed7bf3b29abe9bb31">00066</a>     <span class="keyword">enum</span> <a class="code" href="group__RenderSystem.html#gaa9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a>
<a name="l00067"></a>00067     {
<a name="l00069"></a><a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31a73546a8946a02a34d7958763e0c1034e">00069</a>         <a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31a73546a8946a02a34d7958763e0c1034e" title="No calculated texture coordinates.">TEXCALC_NONE</a>,
<a name="l00071"></a><a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31a414edb1748a8b2bfd8c4699164c46352">00071</a>         <a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31a414edb1748a8b2bfd8c4699164c46352" title="Environment map based on vertex normals.">TEXCALC_ENVIRONMENT_MAP</a>,
<a name="l00073"></a><a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31a516f97319ea6e8a02daef9f13c32303c">00073</a>         <a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31a516f97319ea6e8a02daef9f13c32303c" title="Environment map based on vertex positions.">TEXCALC_ENVIRONMENT_MAP_PLANAR</a>,
<a name="l00074"></a><a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31ad4c1a576294c5fc8a0519783fc9e2eab">00074</a>         <a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31ad4c1a576294c5fc8a0519783fc9e2eab">TEXCALC_ENVIRONMENT_MAP_REFLECTION</a>,
<a name="l00075"></a><a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31aa296599db57208482d35f5d264d61578">00075</a>         <a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31aa296599db57208482d35f5d264d61578">TEXCALC_ENVIRONMENT_MAP_NORMAL</a>,
<a name="l00077"></a><a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31abcbba9b2c16dc5c57c479dfc486095db">00077</a>         <a class="code" href="group__RenderSystem.html#ggaa9c06899edc6b7aed7bf3b29abe9bb31abcbba9b2c16dc5c57c479dfc486095db" title="Projective texture.">TEXCALC_PROJECTIVE_TEXTURE</a>
<a name="l00078"></a>00078     };
<a name="l00080"></a><a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61">00080</a>     <span class="keyword">enum</span> <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a>
<a name="l00081"></a>00081     {
<a name="l00083"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511">00083</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l00085"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a910e7fedb6c873aaad581cfda6491b8a">00085</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a910e7fedb6c873aaad581cfda6491b8a" title="Set the stencil value to zero.">SOP_ZERO</a>,
<a name="l00087"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61acbce9e054c373718a59dd56e51aa762a">00087</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61acbce9e054c373718a59dd56e51aa762a" title="Set the stencil value to the reference value.">SOP_REPLACE</a>,
<a name="l00089"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61ae56b6038f9552a79b2b1d2ae036da86c">00089</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61ae56b6038f9552a79b2b1d2ae036da86c" title="Increase the stencil value by 1, clamping at the maximum value.">SOP_INCREMENT</a>,
<a name="l00091"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a7faeb919637b85bed8650d8f1baf2ada">00091</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a7faeb919637b85bed8650d8f1baf2ada" title="Decrease the stencil value by 1, clamping at 0.">SOP_DECREMENT</a>,
<a name="l00093"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a6e595fbb31308c6b01f35221903f4706">00093</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a6e595fbb31308c6b01f35221903f4706" title="Increase the stencil value by 1, wrapping back to 0 when incrementing the maximum value...">SOP_INCREMENT_WRAP</a>,
<a name="l00095"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61ab816aeb027a4e517237d053e5fedc2a7">00095</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61ab816aeb027a4e517237d053e5fedc2a7" title="Decrease the stencil value by 1, wrapping when decrementing 0.">SOP_DECREMENT_WRAP</a>,
<a name="l00097"></a><a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a4f9045fb414071aa89184ce5e88ec474">00097</a>         <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61a4f9045fb414071aa89184ce5e88ec474" title="Invert the bits of the stencil buffer.">SOP_INVERT</a>
<a name="l00098"></a>00098     };
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00124"></a><a class="code" href="classOgre_1_1RenderSystem.html">00124</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">RenderSysAlloc</a>
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126     <span class="keyword">public</span>:
<a name="l00129"></a>00129         <a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>();
<a name="l00130"></a>00130 
<a name="l00133"></a>00133         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1RenderSystem.html" title="Defines the functionality of a 3D API.">RenderSystem</a>();
<a name="l00134"></a>00134 
<a name="l00137"></a>00137         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getName(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l00138"></a>00138 
<a name="l00160"></a>00160         <span class="keyword">virtual</span> <a class="code" href="group__General.html#gafba22dbf34cd07633293ddba65ee6add">ConfigOptionMap</a>&amp; getConfigOptions(<span class="keywordtype">void</span>) = 0;
<a name="l00161"></a>00161 
<a name="l00181"></a>00181         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setConfigOption(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;value) = 0;
<a name="l00182"></a>00182 
<a name="l00185"></a>00185         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a>* createHardwareOcclusionQuery(<span class="keywordtype">void</span>) = 0;
<a name="l00186"></a>00186 
<a name="l00189"></a>00189         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyHardwareOcclusionQuery(<a class="code" href="classOgre_1_1HardwareOcclusionQuery.html" title="This is a abstract class that that provides the interface for the query class for hardware occlusion...">HardwareOcclusionQuery</a> *hq);
<a name="l00190"></a>00190 
<a name="l00195"></a>00195         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> validateConfigOptions(<span class="keywordtype">void</span>) = 0;
<a name="l00196"></a>00196 
<a name="l00213"></a>00213         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _initialise(<span class="keywordtype">bool</span> autoCreateWindow, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; windowTitle = <span class="stringliteral">&quot;OGRE Render Window&quot;</span>);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00217"></a>00217         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* createRenderSystemCapabilities() <span class="keyword">const</span> = 0;
<a name="l00218"></a>00218  
<a name="l00226"></a><a class="code" href="classOgre_1_1RenderSystem.html#ab0aa0cedf1898f8cc70e290703b428c7">00226</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* <a class="code" href="classOgre_1_1RenderSystem.html#ab0aa0cedf1898f8cc70e290703b428c7" title="Get a pointer to the current capabilities being used by the RenderSystem.">getMutableCapabilities</a>(){ <span class="keywordflow">return</span> mCurrentCapabilities; }
<a name="l00227"></a>00227 
<a name="l00234"></a>00234         <span class="keyword">virtual</span> <span class="keywordtype">void</span> useCustomRenderSystemCapabilities(<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* capabilities);
<a name="l00235"></a>00235 
<a name="l00238"></a>00238         <span class="keyword">virtual</span> <span class="keywordtype">void</span> reinitialise(<span class="keywordtype">void</span>) = 0;
<a name="l00239"></a>00239 
<a name="l00242"></a>00242         <span class="keyword">virtual</span> <span class="keywordtype">void</span> shutdown(<span class="keywordtype">void</span>);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00247"></a>00247         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setAmbientLight(<span class="keywordtype">float</span> r, <span class="keywordtype">float</span> g, <span class="keywordtype">float</span> b) = 0;
<a name="l00248"></a>00248 
<a name="l00251"></a>00251         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setShadingType(<a class="code" href="group__General.html#ga7afd4c7d428baaee13f3a0dbcae5f560" title="Light shading modes.">ShadeOptions</a> so) = 0;
<a name="l00252"></a>00252 
<a name="l00258"></a>00258         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setLightingEnabled(<span class="keywordtype">bool</span> enabled) = 0;
<a name="l00259"></a>00259 
<a name="l00266"></a>00266         <span class="keywordtype">void</span> setWBufferEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00267"></a>00267 
<a name="l00270"></a>00270         <span class="keywordtype">bool</span> getWBufferEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00271"></a>00271 
<a name="l00508"></a>00508         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderWindow.html" title="Manages the target rendering window.">RenderWindow</a>* _createRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> width, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> height, 
<a name="l00509"></a>00509             <span class="keywordtype">bool</span> fullScreen, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a> *miscParams = 0) = 0;
<a name="l00510"></a>00510 
<a name="l00526"></a>00526         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> _createRenderWindows(<span class="keyword">const</span> <a class="code" href="group__General.html#ga7a03bf97326d0d0385b91a74e2c51c5e" title="Render window creation parameters container.">RenderWindowDescriptionList</a>&amp; renderWindowDescriptions, 
<a name="l00527"></a>00527             <a class="code" href="group__General.html#ga1d8e92efee48ea10e75189c8efa6ec51" title="Render window container.">RenderWindowList</a>&amp; createdWindows);
<a name="l00528"></a>00528 
<a name="l00529"></a>00529         
<a name="l00534"></a>00534         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MultiRenderTarget.html" title="This class represents a render target that renders to multiple RenderTextures at once.">MultiRenderTarget</a> * createMultiRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp; name) = 0; 
<a name="l00535"></a>00535 
<a name="l00537"></a>00537         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyRenderWindow(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00539"></a>00539         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyRenderTexture(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00541"></a>00541         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyRenderTarget(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00542"></a>00542 
<a name="l00545"></a>00545         <span class="keyword">virtual</span> <span class="keywordtype">void</span> attachRenderTarget( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> &amp;target );
<a name="l00549"></a>00549         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> * getRenderTarget( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name );
<a name="l00555"></a>00555         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> * detachRenderTarget( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;name );
<a name="l00556"></a>00556 
<a name="l00558"></a><a class="code" href="classOgre_1_1RenderSystem.html#a50a15a7bbc1beca5c91b6584a3060f1b">00558</a>         <span class="keyword">typedef</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">MapIterator&lt;Ogre::RenderTargetMap&gt;</a> <a class="code" href="classOgre_1_1RenderSystem.html#a50a15a7bbc1beca5c91b6584a3060f1b" title="Iterator over RenderTargets.">RenderTargetIterator</a>;
<a name="l00559"></a>00559 
<a name="l00561"></a><a class="code" href="classOgre_1_1RenderSystem.html#a2e8f34e7464302fbce845f1d3fd468c8">00561</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">RenderTargetIterator</a> <a class="code" href="classOgre_1_1RenderSystem.html#a2e8f34e7464302fbce845f1d3fd468c8" title="Returns a specialised MapIterator over all render targets attached to the RenderSystem.">getRenderTargetIterator</a>(<span class="keywordtype">void</span>) {
<a name="l00562"></a>00562             <span class="keywordflow">return</span> <a class="code" href="classOgre_1_1MapIterator.html" title="Concrete IteratorWrapper for nonconst access to the underlying key-value container.">RenderTargetIterator</a>( mRenderTargets.begin(), mRenderTargets.end() );
<a name="l00563"></a>00563         }
<a name="l00566"></a>00566         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> getErrorDescription(<span class="keywordtype">long</span> errorNumber) <span class="keyword">const</span> = 0;
<a name="l00567"></a>00567 
<a name="l00581"></a>00581         <span class="keywordtype">void</span> setWaitForVerticalBlank(<span class="keywordtype">bool</span> enabled);
<a name="l00582"></a>00582 
<a name="l00585"></a>00585         <span class="keywordtype">bool</span> getWaitForVerticalBlank(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00586"></a>00586 
<a name="l00589"></a>00589         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> getGlobalInstanceVertexBuffer() <span class="keyword">const</span>;
<a name="l00592"></a>00592         <span class="keywordtype">void</span> setGlobalInstanceVertexBuffer(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> val);
<a name="l00595"></a>00595         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* getGlobalInstanceVertexBufferVertexDeclaration() <span class="keyword">const</span>;
<a name="l00598"></a>00598         <span class="keywordtype">void</span> setGlobalInstanceVertexBufferVertexDeclaration( <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* val);
<a name="l00601"></a>00601         <span class="keywordtype">size_t</span> getGlobalNumberOfInstances() <span class="keyword">const</span>;
<a name="l00604"></a>00604         <span class="keywordtype">void</span> setGlobalNumberOfInstances(<span class="keyword">const</span> <span class="keywordtype">size_t</span> val);
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_CORE_SHADERS</span>
<a name="l00607"></a>00607 <span class="preprocessor"></span>
<a name="l00609"></a>00609         <span class="keywordtype">void</span> setFixedPipelineEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00610"></a>00610 
<a name="l00613"></a>00613         <span class="keywordtype">bool</span> getFixedPipelineEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00614"></a>00614 <span class="preprocessor">#endif</span>
<a name="l00615"></a>00615 <span class="preprocessor"></span>
<a name="l00621"></a>00621         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDepthBufferFor( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget );
<a name="l00622"></a>00622 
<a name="l00623"></a>00623         <span class="comment">// ------------------------------------------------------------------------</span>
<a name="l00624"></a>00624         <span class="comment">//                     Internal Rendering Access</span>
<a name="l00625"></a>00625         <span class="comment">// All methods below here are normally only called by other OGRE classes</span>
<a name="l00626"></a>00626         <span class="comment">// They can be called by library user if required</span>
<a name="l00627"></a>00627         <span class="comment">// ------------------------------------------------------------------------</span>
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00633"></a>00633         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _useLights(<span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; lights, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> limit) = 0;
<a name="l00636"></a><a class="code" href="classOgre_1_1RenderSystem.html#ae8643baecd1e23f927d41e3535268518">00636</a>         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#ae8643baecd1e23f927d41e3535268518" title="Are fixed-function lights provided in view space? Affects optimisation.">areFixedFunctionLightsInViewSpace</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00638"></a>00638         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setWorldMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m) = 0;
<a name="l00640"></a>00640         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setWorldMatrices(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* m, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> count);
<a name="l00642"></a>00642         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setViewMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m) = 0;
<a name="l00644"></a>00644         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> &amp;m) = 0;
<a name="l00650"></a>00650         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureUnitSettings(<span class="keywordtype">size_t</span> texUnit, <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>&amp; tl);
<a name="l00652"></a>00652         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _disableTextureUnit(<span class="keywordtype">size_t</span> texUnit);
<a name="l00654"></a>00654         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _disableTextureUnitsFrom(<span class="keywordtype">size_t</span> texUnit);
<a name="l00688"></a>00688         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setSurfaceParams(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;ambient,
<a name="l00689"></a>00689             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;diffuse, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;specular,
<a name="l00690"></a>00690             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> &amp;emissive, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> shininess,
<a name="l00691"></a>00691             <a class="code" href="group__General.html#gaf3fdba7211d7078a43201a1721532f9e" title="An enumeration describing which material properties should track the vertex colours.">TrackVertexColourType</a> tracking = <a class="code" href="group__General.html#gga5d04131dcb51ec3cf219465196b6de85a4b75431ccf4b6bde635265300498660e">TVC_NONE</a>) = 0;
<a name="l00692"></a>00692 
<a name="l00698"></a>00698         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setPointSpritesEnabled(<span class="keywordtype">bool</span> enabled) = 0;
<a name="l00699"></a>00699 
<a name="l00710"></a>00710         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setPointParameters(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> size, <span class="keywordtype">bool</span> attenuationEnabled, 
<a name="l00711"></a>00711             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> constant, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linear, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> quadratic, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> minSize, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> maxSize) = 0;
<a name="l00712"></a>00712 
<a name="l00713"></a>00713 
<a name="l00726"></a>00726         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTexture(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">bool</span> enabled, 
<a name="l00727"></a>00727             <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a> &amp;texPtr) = 0;
<a name="l00741"></a>00741         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTexture(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">bool</span> enabled, <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;texname);
<a name="l00742"></a>00742 
<a name="l00752"></a>00752         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setVertexTexture(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1TexturePtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to TexturePtr.">TexturePtr</a>&amp; tex);
<a name="l00753"></a>00753 
<a name="l00763"></a>00763         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureCoordSet(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">size_t</span> index) = 0;
<a name="l00764"></a>00764 
<a name="l00772"></a>00772         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureCoordCalculation(<span class="keywordtype">size_t</span> unit, <a class="code" href="group__RenderSystem.html#gaa9c06899edc6b7aed7bf3b29abe9bb31" title="Enum describing the ways to generate texture coordinates.">TexCoordCalcMethod</a> m, 
<a name="l00773"></a>00773             <span class="keyword">const</span> <a class="code" href="classOgre_1_1Frustum.html" title="A frustum represents a pyramid, capped at the near and far end which is used to represent either a vi...">Frustum</a>* frustum = 0) = 0;
<a name="l00774"></a>00774 
<a name="l00781"></a>00781         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureBlendMode(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1LayerBlendModeEx.html" title="Class which manages blending of both colour and alpha components.">LayerBlendModeEx</a>&amp; bm) = 0;
<a name="l00782"></a>00782 
<a name="l00789"></a>00789         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureUnitFiltering(<span class="keywordtype">size_t</span> unit, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> minFilter,
<a name="l00790"></a>00790             <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> magFilter, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> mipFilter);
<a name="l00791"></a>00791 
<a name="l00797"></a>00797         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureUnitFiltering(<span class="keywordtype">size_t</span> unit, <a class="code" href="group__General.html#gac1fc36ec2f4df4b2afa9fa39f9c66c06">FilterType</a> ftype, <a class="code" href="group__General.html#ga02306c6246268d35f45ad22278bd5d3d" title="Filtering options for textures / mipmaps.">FilterOptions</a> filter) = 0;
<a name="l00798"></a>00798 
<a name="l00800"></a>00800         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureLayerAnisotropy(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxAnisotropy) = 0;
<a name="l00801"></a>00801 
<a name="l00803"></a>00803         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureAddressingMode(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="structOgre_1_1TextureUnitState_1_1UVWAddressingMode.html" title="Texture addressing mode for each texture coordinate.">TextureUnitState::UVWAddressingMode</a>&amp; uvw) = 0;
<a name="l00804"></a>00804 
<a name="l00806"></a>00806         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureBorderColour(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour) = 0;
<a name="l00807"></a>00807 
<a name="l00816"></a>00816         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureMipmapBias(<span class="keywordtype">size_t</span> unit, <span class="keywordtype">float</span> bias) = 0;
<a name="l00817"></a>00817 
<a name="l00822"></a>00822         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureMatrix(<span class="keywordtype">size_t</span> unit, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; xform) = 0;
<a name="l00823"></a>00823 
<a name="l00834"></a>00834         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setSceneBlending(<a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op = <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aa188aee58620b3275f1a45c7c80df4bc7">SBO_ADD</a>) = 0;
<a name="l00835"></a>00835 
<a name="l00848"></a>00848         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setSeparateSceneBlending(<a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactor, <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> sourceFactorAlpha, 
<a name="l00849"></a>00849             <a class="code" href="group__Materials.html#ga41c76d419d6c9c205a6c1d3b42872213" title="Blending factors for manually blending objects with the scene.">SceneBlendFactor</a> destFactorAlpha, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> op = <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aa188aee58620b3275f1a45c7c80df4bc7">SBO_ADD</a>, <a class="code" href="group__Materials.html#gaa7a12a72231aedf6e33d58aafc11214a" title="Blending operations controls how objects are blended into the scene.">SceneBlendOperation</a> alphaOp = <a class="code" href="group__Materials.html#ggaa7a12a72231aedf6e33d58aafc11214aa188aee58620b3275f1a45c7c80df4bc7">SBO_ADD</a>) = 0;
<a name="l00850"></a>00850 
<a name="l00857"></a>00857         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setAlphaRejectSettings(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> value, <span class="keywordtype">bool</span> alphaToCoverage) = 0;
<a name="l00858"></a>00858 
<a name="l00862"></a>00862         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setTextureProjectionRelativeTo(<span class="keywordtype">bool</span> enabled, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a>&amp; pos);
<a name="l00863"></a>00863 
<a name="l00871"></a>00871         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1DepthBuffer.html" title="An abstract class that contains a depth/stencil buffer.">DepthBuffer</a>* _createDepthBufferFor( <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *renderTarget ) = 0;
<a name="l00872"></a>00872 
<a name="l00880"></a>00880         <span class="keywordtype">void</span> _cleanupDepthBuffers( <span class="keywordtype">bool</span> bCleanManualBuffers=<span class="keyword">true</span> );
<a name="l00881"></a>00881 
<a name="l00886"></a>00886         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _beginFrame(<span class="keywordtype">void</span>) = 0;
<a name="l00887"></a>00887         
<a name="l00888"></a>00888         <span class="comment">//Dummy structure for render system contexts - implementing RenderSystems can extend</span>
<a name="l00889"></a>00889         <span class="comment">//as needed</span>
<a name="l00890"></a><a class="code" href="structOgre_1_1RenderSystem_1_1RenderSystemContext.html">00890</a>         <span class="keyword">struct </span><a class="code" href="structOgre_1_1RenderSystem_1_1RenderSystemContext.html">RenderSystemContext</a> { };
<a name="l00896"></a>00896         <span class="keyword">virtual</span> <a class="code" href="structOgre_1_1RenderSystem_1_1RenderSystemContext.html">RenderSystemContext</a>* _pauseFrame(<span class="keywordtype">void</span>);
<a name="l00903"></a>00903         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _resumeFrame(<a class="code" href="structOgre_1_1RenderSystem_1_1RenderSystemContext.html">RenderSystemContext</a>* context);
<a name="l00904"></a>00904 
<a name="l00908"></a>00908         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _endFrame(<span class="keywordtype">void</span>) = 0;
<a name="l00916"></a>00916         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setViewport(<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a> *vp) = 0;
<a name="l00918"></a>00918         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* _getViewport(<span class="keywordtype">void</span>);
<a name="l00919"></a>00919 
<a name="l00931"></a>00931         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setCullingMode(<a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> mode) = 0;
<a name="l00932"></a>00932 
<a name="l00933"></a>00933         <span class="keyword">virtual</span> <a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> _getCullingMode(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00934"></a>00934 
<a name="l00948"></a>00948         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferParams(<span class="keywordtype">bool</span> depthTest = <span class="keyword">true</span>, <span class="keywordtype">bool</span> depthWrite = <span class="keyword">true</span>, <a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> depthFunction = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>) = 0;
<a name="l00949"></a>00949 
<a name="l00954"></a>00954         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferCheckEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>) = 0;
<a name="l00959"></a>00959         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferWriteEnabled(<span class="keywordtype">bool</span> enabled = <span class="keyword">true</span>) = 0;
<a name="l00967"></a>00967         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBufferFunction(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aa2272d0faefcf5a2e08bbf7d232d7520b">CMPF_LESS_EQUAL</a>) = 0;
<a name="l00975"></a>00975         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setColourBufferWriteEnabled(<span class="keywordtype">bool</span> red, <span class="keywordtype">bool</span> green, <span class="keywordtype">bool</span> blue, <span class="keywordtype">bool</span> alpha) = 0;
<a name="l00998"></a>00998         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setDepthBias(<span class="keywordtype">float</span> constantBias, <span class="keywordtype">float</span> slopeScaleBias = 0.0f) = 0;
<a name="l01010"></a>01010         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setFog(<a class="code" href="group__General.html#ga83edeb2e5d33a3ca8f15834ba40020ba" title="Fog modes.">FogMode</a> mode = <a class="code" href="group__General.html#gga83edeb2e5d33a3ca8f15834ba40020baab7793a21880052c0214d4cc040992310" title="No fog. Duh.">FOG_NONE</a>, <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a8eba66b2908f44f00f8d9c9ec25877de">ColourValue::White</a>, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> expDensity = 1.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearStart = 0.0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> linearEnd = 1.0) = 0;
<a name="l01011"></a>01011 
<a name="l01012"></a>01012 
<a name="l01014"></a>01014         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _beginGeometryCount(<span class="keywordtype">void</span>);
<a name="l01016"></a>01016         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getFaceCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01018"></a>01018         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getBatchCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01020"></a>01020         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getVertexCount(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01021"></a>01021 
<a name="l01030"></a>01030         <span class="keyword">virtual</span> <span class="keywordtype">void</span> convertColourValue(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a>* pDest);
<a name="l01034"></a>01034         <span class="keyword">virtual</span> <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> getColourVertexElementType(<span class="keywordtype">void</span>) <span class="keyword">const</span> = 0;
<a name="l01035"></a>01035 
<a name="l01042"></a>01042         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _convertProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix,
<a name="l01043"></a>01043             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l01044"></a>01044 
<a name="l01051"></a>01051         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _makeProjectionMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l01052"></a>01052             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l01053"></a>01053 
<a name="l01060"></a>01060         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _makeProjectionMatrix(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> right, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> bottom, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, 
<a name="l01061"></a>01061             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l01068"></a>01068         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _makeOrthoMatrix(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Radian.html" title="Wrapper class which indicates a given angle value is in Radians.">Radian</a>&amp; fovy, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> aspect, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> nearPlane, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> farPlane, 
<a name="l01069"></a>01069             <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; dest, <span class="keywordtype">bool</span> forGpuProgram = <span class="keyword">false</span>) = 0;
<a name="l01070"></a>01070 
<a name="l01087"></a>01087         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _applyObliqueDepthProjection(<a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; matrix, <span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a>&amp; plane, 
<a name="l01088"></a>01088             <span class="keywordtype">bool</span> forGpuProgram) = 0;
<a name="l01089"></a>01089 
<a name="l01091"></a>01091         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setPolygonMode(<a class="code" href="group__General.html#ga68866b02aa7f99e3431337511fbb3345" title="The polygon mode to use when rasterising.">PolygonMode</a> level) = 0;
<a name="l01092"></a>01092 
<a name="l01099"></a>01099         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setStencilCheckEnabled(<span class="keywordtype">bool</span> enabled) = 0;
<a name="l01115"></a>01115         <span class="comment">/*virtual bool hasHardwareStencil(void) = 0;*/</span>
<a name="l01116"></a>01116 
<a name="l01152"></a>01152         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setStencilBufferParams(<a class="code" href="group__General.html#ga0212b4eb264f207d84c1df9425208c7a" title="Comparison functions used for the depth/stencil buffer operations and others.">CompareFunction</a> func = <a class="code" href="group__General.html#gga0212b4eb264f207d84c1df9425208c7aae10ea1648cd8c9bd90bdaccaa11cbc4e">CMPF_ALWAYS_PASS</a>, 
<a name="l01153"></a>01153             <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> refValue = 0, <a class="code" href="namespaceOgre.html#adf2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask = 0xFFFFFFFF, 
<a name="l01154"></a>01154             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> stencilFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l01155"></a>01155             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> depthFailOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>,
<a name="l01156"></a>01156             <a class="code" href="group__RenderSystem.html#gae8bb1cb809660de802d1d592ba4adb61" title="Enum describing the various actions which can be taken onthe stencil buffer.">StencilOperation</a> passOp = <a class="code" href="group__RenderSystem.html#ggae8bb1cb809660de802d1d592ba4adb61abf640cb28b5020509dc27178f0359511" title="Leave the stencil buffer unchanged.">SOP_KEEP</a>, 
<a name="l01157"></a>01157             <span class="keywordtype">bool</span> twoSidedOperation = <span class="keyword">false</span>) = 0;
<a name="l01158"></a>01158 
<a name="l01159"></a>01159 
<a name="l01160"></a>01160 
<a name="l01162"></a>01162         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl) = 0;
<a name="l01164"></a>01164         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setVertexBufferBinding(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding) = 0;
<a name="l01165"></a>01165 
<a name="l01176"></a>01176         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setNormaliseNormals(<span class="keywordtype">bool</span> normalise) = 0;
<a name="l01177"></a>01177 
<a name="l01190"></a>01190         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _render(<span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l01191"></a>01191 
<a name="l01193"></a><a class="code" href="classOgre_1_1RenderSystem.html#a1ea7609b7337a8b184c4348b09d5c46a">01193</a>         <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* <a class="code" href="classOgre_1_1RenderSystem.html#a1ea7609b7337a8b184c4348b09d5c46a" title="Gets the capabilities of the render system.">getCapabilities</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mCurrentCapabilities; }
<a name="l01194"></a>01194 
<a name="l01195"></a>01195 
<a name="l01198"></a><a class="code" href="classOgre_1_1RenderSystem.html#ad9dbbbf4ae4dc539ebb31d99c7e6c724">01198</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="structOgre_1_1DriverVersion.html" title="DriverVersion is used by RenderSystemCapabilities and both GL and D3D9 to store the version of the cu...">DriverVersion</a>&amp; <a class="code" href="classOgre_1_1RenderSystem.html#ad9dbbbf4ae4dc539ebb31d99c7e6c724" title="Returns the driver version.">getDriverVersion</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mDriverVersion; }
<a name="l01199"></a>01199 
<a name="l01209"></a>01209         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; _getDefaultViewportMaterialScheme(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01210"></a>01210 
<a name="l01215"></a>01215         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindGpuProgram(<a class="code" href="classOgre_1_1GpuProgram.html" title="Defines a program which runs on the GPU such as a vertex or fragment program.">GpuProgram</a>* prg);
<a name="l01216"></a>01216 
<a name="l01222"></a>01222         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindGpuProgramParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype, 
<a name="l01223"></a>01223             <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params, <a class="code" href="namespaceOgre.html#aa8263b218e7d187ad5ef03a73a6ad7fd">uint16</a> variabilityMask) = 0;
<a name="l01224"></a>01224 
<a name="l01227"></a>01227         <span class="keyword">virtual</span> <span class="keywordtype">void</span> bindGpuProgramPassIterationParameters(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype) = 0;
<a name="l01232"></a>01232         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unbindGpuProgram(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l01233"></a>01233 
<a name="l01235"></a>01235         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> isGpuProgramBound(<a class="code" href="group__Resources.html#gad08e89fa63e81d061ea9e2f37664976e" title="Enumerates the types of programs which can run on the GPU.">GpuProgramType</a> gptype);
<a name="l01236"></a>01236 
<a name="l01239"></a>01239         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setClipPlanes(<span class="keyword">const</span> <a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">PlaneList</a>&amp; clipPlanes);
<a name="l01240"></a>01240 
<a name="l01242"></a>01242         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addClipPlane (<span class="keyword">const</span> <a class="code" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> &amp;p);
<a name="l01244"></a>01244         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addClipPlane (<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> A, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> B, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> C, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> D);
<a name="l01245"></a>01245 
<a name="l01248"></a>01248         <span class="keyword">virtual</span> <span class="keywordtype">void</span> resetClipPlanes();
<a name="l01249"></a>01249 
<a name="l01251"></a>01251         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _initRenderTargets(<span class="keywordtype">void</span>);
<a name="l01252"></a>01252 
<a name="l01256"></a>01256         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCameraRemoved(<span class="keyword">const</span> <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l01257"></a>01257 
<a name="l01259"></a>01259         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateAllRenderTargets(<span class="keywordtype">bool</span> swapBuffers = <span class="keyword">true</span>);
<a name="l01262"></a>01262         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _swapAllRenderTargetBuffers(<span class="keywordtype">bool</span> waitForVsync = <span class="keyword">true</span>);
<a name="l01263"></a>01263 
<a name="l01266"></a>01266         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInvertVertexWinding(<span class="keywordtype">bool</span> invert);
<a name="l01267"></a>01267 
<a name="l01271"></a>01271         <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getInvertVertexWinding(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l01272"></a>01272 
<a name="l01284"></a>01284         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setScissorTest(<span class="keywordtype">bool</span> enabled, <span class="keywordtype">size_t</span> left = 0, <span class="keywordtype">size_t</span> top = 0, 
<a name="l01285"></a>01285             <span class="keywordtype">size_t</span> right = 800, <span class="keywordtype">size_t</span> bottom = 600) = 0;
<a name="l01286"></a>01286 
<a name="l01294"></a>01294         <span class="keyword">virtual</span> <span class="keywordtype">void</span> clearFrameBuffer(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffers, 
<a name="l01295"></a>01295             <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour = <a class="code" href="classOgre_1_1ColourValue.html#a7f8a06f2a9dd645417c36b560f496c1a">ColourValue::Black</a>, 
<a name="l01296"></a>01296             <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> depth = 1.0f, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> stencil = 0) = 0;
<a name="l01306"></a>01306         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getHorizontalTexelOffset(<span class="keywordtype">void</span>) = 0;
<a name="l01316"></a>01316         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getVerticalTexelOffset(<span class="keywordtype">void</span>) = 0;
<a name="l01317"></a>01317 
<a name="l01326"></a>01326         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMinimumDepthInputValue(<span class="keywordtype">void</span>) = 0;
<a name="l01335"></a>01335         <span class="keyword">virtual</span> <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getMaximumDepthInputValue(<span class="keywordtype">void</span>) = 0;
<a name="l01341"></a><a class="code" href="classOgre_1_1RenderSystem.html#a207d38c53699525e2e49ee167f9c8eb5">01341</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1RenderSystem.html#a207d38c53699525e2e49ee167f9c8eb5" title="set the current multi pass count value.">setCurrentPassIterationCount</a>(<span class="keyword">const</span> <span class="keywordtype">size_t</span> count) { mCurrentPassIterationCount = count; }
<a name="l01342"></a>01342 
<a name="l01352"></a><a class="code" href="classOgre_1_1RenderSystem.html#a927af19c2746aa2dd37018434bfc09f4">01352</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setDeriveDepthBias(<span class="keywordtype">bool</span> derive, <span class="keywordtype">float</span> baseValue = 0.0f,
<a name="l01353"></a>01353             <span class="keywordtype">float</span> multiplier = 0.0f, <span class="keywordtype">float</span> slopeScale = 0.0f)
<a name="l01354"></a>01354         {
<a name="l01355"></a>01355             mDerivedDepthBias = derive;
<a name="l01356"></a>01356             mDerivedDepthBiasBase = baseValue;
<a name="l01357"></a>01357             mDerivedDepthBiasMultiplier = multiplier;
<a name="l01358"></a>01358             mDerivedDepthBiasSlopeScale = slopeScale;
<a name="l01359"></a>01359         }
<a name="l01360"></a>01360 
<a name="l01364"></a>01364         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _setRenderTarget(<a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> *target) = 0;
<a name="l01365"></a>01365 
<a name="l01370"></a><a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html">01370</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html" title="Defines a listener on the custom events that this render system can raise.">Listener</a>
<a name="l01371"></a>01371         {
<a name="l01372"></a>01372         <span class="keyword">public</span>:
<a name="l01373"></a><a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html#a2ccefd2fe4eb8ca096e8ec7efbefc413">01373</a>             <a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html#a2ccefd2fe4eb8ca096e8ec7efbefc413">Listener</a>() {}
<a name="l01374"></a><a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html#a92f2b3702187d4893f0a28993510f759">01374</a>             <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1RenderSystem_1_1Listener.html#a92f2b3702187d4893f0a28993510f759">~Listener</a>() {}
<a name="l01375"></a>01375 
<a name="l01381"></a>01381             <span class="keyword">virtual</span> <span class="keywordtype">void</span> eventOccurred(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; eventName, 
<a name="l01382"></a>01382                 <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* parameters = 0) = 0;
<a name="l01383"></a>01383         };
<a name="l01397"></a>01397         <span class="keyword">virtual</span> <span class="keywordtype">void</span> addListener(Listener* l);
<a name="l01400"></a>01400         <span class="keyword">virtual</span> <span class="keywordtype">void</span> removeListener(Listener* l);
<a name="l01401"></a>01401 
<a name="l01406"></a><a class="code" href="classOgre_1_1RenderSystem.html#a8f3b7402316e7162fb5778235fc6e2f2">01406</a>         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a>&amp; <a class="code" href="classOgre_1_1RenderSystem.html#a8f3b7402316e7162fb5778235fc6e2f2" title="Gets a list of the rendersystem specific events that this rendersystem can raise.">getRenderSystemEvents</a>(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mEventNames; }
<a name="l01407"></a>01407 
<a name="l01424"></a>01424         <span class="keyword">virtual</span> <span class="keywordtype">void</span> preExtraThreadsStarted() = 0;
<a name="l01425"></a>01425 
<a name="l01426"></a>01426         <span class="comment">/* Tell the rendersystem to perform any tasks it needs to directly</span>
<a name="l01427"></a>01427 <span class="comment">        after other threads which might access the rendering API are registered.</span>
<a name="l01428"></a>01428 <span class="comment">        @see RenderSystem::preExtraThreadsStarted</span>
<a name="l01429"></a>01429 <span class="comment">        */</span>
<a name="l01430"></a>01430         <span class="keyword">virtual</span> <span class="keywordtype">void</span> postExtraThreadsStarted() = 0;
<a name="l01431"></a>01431 
<a name="l01444"></a>01444         <span class="keyword">virtual</span> <span class="keywordtype">void</span> registerThread() = 0;
<a name="l01445"></a>01445 
<a name="l01449"></a>01449         <span class="keyword">virtual</span> <span class="keywordtype">void</span> unregisterThread() = 0;
<a name="l01450"></a>01450 
<a name="l01455"></a>01455         <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getDisplayMonitorCount() <span class="keyword">const</span> = 0;
<a name="l01456"></a>01456     <span class="keyword">protected</span>:
<a name="l01457"></a>01457 
<a name="l01459"></a><a class="code" href="classOgre_1_1RenderSystem.html#ac2e020886998e27c45608206308d3756">01459</a>         <a class="code" href="group__RenderSystem.html#ga6976cd039d94260fb992a6fd1f072133">DepthBufferMap</a>  <a class="code" href="classOgre_1_1RenderSystem.html#ac2e020886998e27c45608206308d3756" title="DepthBuffers to be attached to render targets.">mDepthBufferPool</a>;
<a name="l01460"></a>01460 
<a name="l01462"></a><a class="code" href="classOgre_1_1RenderSystem.html#a5ea599be4da15690178a9aca2261e992">01462</a>         <a class="code" href="group__RenderSystem.html#ga0fc2f530f0d042c937e49131cde29245">RenderTargetMap</a> <a class="code" href="classOgre_1_1RenderSystem.html#a5ea599be4da15690178a9aca2261e992" title="The render targets.">mRenderTargets</a>;
<a name="l01464"></a><a class="code" href="classOgre_1_1RenderSystem.html#a69c3a5daa75ce78fd56226941f1c8126">01464</a>         <a class="code" href="group__RenderSystem.html#ga49f68547d022aa6d7f10745ea069ebd9">RenderTargetPriorityMap</a> <a class="code" href="classOgre_1_1RenderSystem.html#a69c3a5daa75ce78fd56226941f1c8126" title="The render targets, ordered by priority.">mPrioritisedRenderTargets</a>;
<a name="l01466"></a><a class="code" href="classOgre_1_1RenderSystem.html#a398254faea8f9fe6454abb38eee5b3f4">01466</a>         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a> * <a class="code" href="classOgre_1_1RenderSystem.html#a398254faea8f9fe6454abb38eee5b3f4" title="The Active render target.">mActiveRenderTarget</a>;
<a name="l01467"></a>01467 
<a name="l01469"></a><a class="code" href="classOgre_1_1RenderSystem.html#ae98e8807b322bccf0eb160afdb54537e">01469</a>         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="classOgre_1_1RenderSystem.html#ae98e8807b322bccf0eb160afdb54537e" title="The Active GPU programs and gpu program parameters.">mActiveVertexGpuProgramParameters</a>;
<a name="l01470"></a><a class="code" href="classOgre_1_1RenderSystem.html#a2d602052ff01a8fd78455916c57a4cef">01470</a>         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="classOgre_1_1RenderSystem.html#a2d602052ff01a8fd78455916c57a4cef">mActiveGeometryGpuProgramParameters</a>;
<a name="l01471"></a><a class="code" href="classOgre_1_1RenderSystem.html#a5b9972dd9bb47c45732ad1c82c55817d">01471</a>         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="classOgre_1_1RenderSystem.html#a5b9972dd9bb47c45732ad1c82c55817d">mActiveFragmentGpuProgramParameters</a>;
<a name="l01472"></a>01472 
<a name="l01473"></a>01473         <span class="comment">// Texture manager</span>
<a name="l01474"></a>01474         <span class="comment">// A concrete class of this will be created and</span>
<a name="l01475"></a>01475         <span class="comment">// made available under the TextureManager singleton,</span>
<a name="l01476"></a>01476         <span class="comment">// managed by the RenderSystem</span>
<a name="l01477"></a><a class="code" href="classOgre_1_1RenderSystem.html#a80f14e152184bddc68f8ae05bcefb3be">01477</a>         <a class="code" href="classOgre_1_1TextureManager.html" title="Class for loading &amp; managing textures.">TextureManager</a>* <a class="code" href="classOgre_1_1RenderSystem.html#a80f14e152184bddc68f8ae05bcefb3be">mTextureManager</a>;
<a name="l01478"></a>01478 
<a name="l01479"></a>01479         <span class="comment">// Active viewport (dest for future rendering operations)</span>
<a name="l01480"></a><a class="code" href="classOgre_1_1RenderSystem.html#a122f2e8cbddd313582f05677f5a26b1c">01480</a>         <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>* <a class="code" href="classOgre_1_1RenderSystem.html#a122f2e8cbddd313582f05677f5a26b1c">mActiveViewport</a>;
<a name="l01481"></a>01481 
<a name="l01482"></a><a class="code" href="classOgre_1_1RenderSystem.html#a60ce74b29c3e1c9e11041029117a85ad">01482</a>         <a class="code" href="group__General.html#gac173244ed7d950d0acd726e4f323ecdb" title="Hardware culling modes based on vertex winding.">CullingMode</a> <a class="code" href="classOgre_1_1RenderSystem.html#a60ce74b29c3e1c9e11041029117a85ad">mCullingMode</a>;
<a name="l01483"></a>01483 
<a name="l01484"></a><a class="code" href="classOgre_1_1RenderSystem.html#ac0df5de57fa3480f74c98c65a7211a30">01484</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#ac0df5de57fa3480f74c98c65a7211a30">mVSync</a>;
<a name="l01485"></a><a class="code" href="classOgre_1_1RenderSystem.html#aae9bef04f53864a06012711ea3857fc6">01485</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classOgre_1_1RenderSystem.html#aae9bef04f53864a06012711ea3857fc6">mVSyncInterval</a>;
<a name="l01486"></a><a class="code" href="classOgre_1_1RenderSystem.html#a7c4ad7937f023a43ee43473750d2bfe9">01486</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#a7c4ad7937f023a43ee43473750d2bfe9">mWBuffer</a>;
<a name="l01487"></a>01487 
<a name="l01488"></a><a class="code" href="classOgre_1_1RenderSystem.html#a039fe39c5374812e776c677404f00898">01488</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderSystem.html#a039fe39c5374812e776c677404f00898">mBatchCount</a>;
<a name="l01489"></a><a class="code" href="classOgre_1_1RenderSystem.html#aa735bd71b568209de09adfa86b737737">01489</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderSystem.html#aa735bd71b568209de09adfa86b737737">mFaceCount</a>;
<a name="l01490"></a><a class="code" href="classOgre_1_1RenderSystem.html#a0716f3fd1349f7c4399d805d03e4c394">01490</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderSystem.html#a0716f3fd1349f7c4399d805d03e4c394">mVertexCount</a>;
<a name="l01491"></a>01491 
<a name="l01493"></a><a class="code" href="classOgre_1_1RenderSystem.html#aa40237e355676bb7024fccd8699eee96">01493</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mManualBlendColours[<a class="code" href="OgreConfig_8h.html#a1c5fd80e6e0f2f85d6facbe1ec8eb5a4" title="Define max number of texture layers allowed per pass on any card.">OGRE_MAX_TEXTURE_LAYERS</a>][2];
<a name="l01494"></a>01494 
<a name="l01495"></a><a class="code" href="classOgre_1_1RenderSystem.html#adf3d0f2e777d97e2032ef01cb1b3ecee">01495</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#adf3d0f2e777d97e2032ef01cb1b3ecee">mInvertVertexWinding</a>;
<a name="l01496"></a>01496 
<a name="l01498"></a><a class="code" href="classOgre_1_1RenderSystem.html#a9a071dab9e9b40bfde6d2e85cb363274">01498</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderSystem.html#a9a071dab9e9b40bfde6d2e85cb363274" title="Texture units from this upwards are disabled.">mDisabledTexUnitsFrom</a>;
<a name="l01499"></a>01499 
<a name="l01501"></a><a class="code" href="classOgre_1_1RenderSystem.html#a179ea5dd6f5b8f1430ebc10dd582fdb8">01501</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderSystem.html#a179ea5dd6f5b8f1430ebc10dd582fdb8" title="number of times to render the current state">mCurrentPassIterationCount</a>;
<a name="l01502"></a><a class="code" href="classOgre_1_1RenderSystem.html#a633705eb827ce4ad1a0d65761d31335c">01502</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderSystem.html#a633705eb827ce4ad1a0d65761d31335c">mCurrentPassIterationNum</a>;
<a name="l01504"></a><a class="code" href="classOgre_1_1RenderSystem.html#ad3c918fb9e33cd75b9a802d48acc800d">01504</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#ad3c918fb9e33cd75b9a802d48acc800d" title="Whether to update the depth bias per render call.">mDerivedDepthBias</a>;
<a name="l01505"></a><a class="code" href="classOgre_1_1RenderSystem.html#ab852c2a4d985484527f4a701dad60981">01505</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1RenderSystem.html#ab852c2a4d985484527f4a701dad60981">mDerivedDepthBiasBase</a>;
<a name="l01506"></a><a class="code" href="classOgre_1_1RenderSystem.html#a55404396ef70888e6d7bf0e1d4177c8b">01506</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1RenderSystem.html#a55404396ef70888e6d7bf0e1d4177c8b">mDerivedDepthBiasMultiplier</a>;
<a name="l01507"></a><a class="code" href="classOgre_1_1RenderSystem.html#a671636ab611261911a21f52d7cc1c97a">01507</a>         <span class="keywordtype">float</span> <a class="code" href="classOgre_1_1RenderSystem.html#a671636ab611261911a21f52d7cc1c97a">mDerivedDepthBiasSlopeScale</a>;
<a name="l01508"></a>01508 
<a name="l01510"></a><a class="code" href="classOgre_1_1RenderSystem.html#a5ba7bb72708c2e6ab08eb57145208d90">01510</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1RenderSystem.html#a5ba7bb72708c2e6ab08eb57145208d90" title="a global vertex buffer for global instancing">mGlobalInstanceVertexBuffer</a>;
<a name="l01512"></a><a class="code" href="classOgre_1_1RenderSystem.html#aca0f02a2c01976d636303dd521631192">01512</a>         <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* <a class="code" href="classOgre_1_1RenderSystem.html#aca0f02a2c01976d636303dd521631192" title="a vertex declaration for the global vertex buffer for the global instancing">mGlobalInstanceVertexBufferVertexDeclaration</a>;
<a name="l01514"></a><a class="code" href="classOgre_1_1RenderSystem.html#a67884ecedea5a989c3da73a6f0860da7">01514</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1RenderSystem.html#a67884ecedea5a989c3da73a6f0860da7" title="the number of global instances (this number will be multiply by the render op instance number)...">mGlobalNumberOfInstances</a>;
<a name="l01515"></a>01515 
<a name="l01516"></a>01516 <span class="preprocessor">#ifdef RTSHADER_SYSTEM_BUILD_CORE_SHADERS</span>
<a name="l01517"></a>01517 <span class="preprocessor"></span>
<a name="l01518"></a>01518         <span class="keywordtype">bool</span> mEnableFixedPipeline;
<a name="l01519"></a>01519 <span class="preprocessor">#endif</span>
<a name="l01520"></a>01520 <span class="preprocessor"></span>
<a name="l01525"></a>01525         <span class="keywordtype">bool</span> updatePassIterationRenderState(<span class="keywordtype">void</span>);
<a name="l01526"></a>01526 
<a name="l01528"></a><a class="code" href="classOgre_1_1RenderSystem.html#ab213f4023f49f961377aa52c8c11acc3">01528</a>         <a class="code" href="group__General.html#ga0899c03496d3c25c6555889aa76a78db">StringVector</a> <a class="code" href="classOgre_1_1RenderSystem.html#ab213f4023f49f961377aa52c8c11acc3" title="List of names of events this rendersystem may raise.">mEventNames</a>;
<a name="l01529"></a>01529 
<a name="l01531"></a>01531         <span class="keyword">virtual</span> <span class="keywordtype">void</span> fireEvent(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name, <span class="keyword">const</span> <a class="code" href="group__General.html#gadccb207c184efc0a6fb2a00ab6320d19" title="Name / value parameter pair (first = name, second = value)">NameValuePairList</a>* params = 0);
<a name="l01532"></a>01532 
<a name="l01533"></a><a class="code" href="classOgre_1_1RenderSystem.html#ab1bb1a0a6617b68f8d05ab81b9d939f3">01533</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;Listener*&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystem.html#ab1bb1a0a6617b68f8d05ab81b9d939f3">ListenerList</a>;
<a name="l01534"></a><a class="code" href="classOgre_1_1RenderSystem.html#ad0cf554e93303c9305d3446eb2efb411">01534</a>         <a class="code" href="classOgre_1_1RenderSystem.html#ab1bb1a0a6617b68f8d05ab81b9d939f3">ListenerList</a> <a class="code" href="classOgre_1_1RenderSystem.html#ad0cf554e93303c9305d3446eb2efb411">mEventListeners</a>;
<a name="l01535"></a>01535 
<a name="l01536"></a><a class="code" href="classOgre_1_1RenderSystem.html#ae5a2c5b72bc48a8b525ce7f305af11ce">01536</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1list.html">list&lt;HardwareOcclusionQuery*&gt;::type</a> <a class="code" href="classOgre_1_1RenderSystem.html#ae5a2c5b72bc48a8b525ce7f305af11ce">HardwareOcclusionQueryList</a>;
<a name="l01537"></a><a class="code" href="classOgre_1_1RenderSystem.html#a7bb1437e3f40cda2bb1495b51ba88791">01537</a>         <a class="code" href="classOgre_1_1RenderSystem.html#ae5a2c5b72bc48a8b525ce7f305af11ce">HardwareOcclusionQueryList</a> <a class="code" href="classOgre_1_1RenderSystem.html#a7bb1437e3f40cda2bb1495b51ba88791">mHwOcclusionQueries</a>;
<a name="l01538"></a>01538 
<a name="l01539"></a><a class="code" href="classOgre_1_1RenderSystem.html#a69173bf6d120d39f702c5de9e0815218">01539</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#a69173bf6d120d39f702c5de9e0815218">mVertexProgramBound</a>;
<a name="l01540"></a><a class="code" href="classOgre_1_1RenderSystem.html#a989d395609174738d5571fb6892262de">01540</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#a989d395609174738d5571fb6892262de">mGeometryProgramBound</a>;
<a name="l01541"></a><a class="code" href="classOgre_1_1RenderSystem.html#a79ba9d85873031a65a9548e65e50109d">01541</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#a79ba9d85873031a65a9548e65e50109d">mFragmentProgramBound</a>;
<a name="l01542"></a>01542 
<a name="l01543"></a>01543         <span class="comment">// Recording user clip planes</span>
<a name="l01544"></a><a class="code" href="classOgre_1_1RenderSystem.html#a07c97ddc40ee60325e0bc21930ac5c79">01544</a>         <a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">PlaneList</a> <a class="code" href="classOgre_1_1RenderSystem.html#a07c97ddc40ee60325e0bc21930ac5c79">mClipPlanes</a>;
<a name="l01545"></a>01545         <span class="comment">// Indicator that we need to re-set the clip planes on next render call</span>
<a name="l01546"></a><a class="code" href="classOgre_1_1RenderSystem.html#a3d14dfbb2f08906b57df424f9cd96bed">01546</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#a3d14dfbb2f08906b57df424f9cd96bed">mClipPlanesDirty</a>;
<a name="l01547"></a>01547 
<a name="l01549"></a><a class="code" href="classOgre_1_1RenderSystem.html#aa4c73904a4dc7b0c097d21acac1ec52f">01549</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* <a class="code" href="classOgre_1_1RenderSystem.html#aa4c73904a4dc7b0c097d21acac1ec52f" title="Used to store the capabilities of the graphics card.">mRealCapabilities</a>;
<a name="l01550"></a><a class="code" href="classOgre_1_1RenderSystem.html#a748f3ed723a45617a5adfd6c8d4decf2">01550</a>         <a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* <a class="code" href="classOgre_1_1RenderSystem.html#a748f3ed723a45617a5adfd6c8d4decf2">mCurrentCapabilities</a>;
<a name="l01551"></a><a class="code" href="classOgre_1_1RenderSystem.html#ab68aeffbe5cb555e1057c0ac3afcee54">01551</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#ab68aeffbe5cb555e1057c0ac3afcee54">mUseCustomCapabilities</a>;
<a name="l01552"></a>01552 
<a name="l01554"></a>01554         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setClipPlanesImpl(<span class="keyword">const</span> <a class="code" href="group__Math.html#gae00d718daa48567f6c010aad9d6dd92c">PlaneList</a>&amp; clipPlanes) = 0;
<a name="l01555"></a>01555 
<a name="l01557"></a>01557         <span class="keyword">virtual</span> <span class="keywordtype">void</span> initialiseFromRenderSystemCapabilities(<a class="code" href="classOgre_1_1RenderSystemCapabilities.html" title="singleton class for storing the capabilities of the graphics card.">RenderSystemCapabilities</a>* caps, <a class="code" href="classOgre_1_1RenderTarget.html" title="A &#39;canvas&#39; which can receive the results of a rendering operation.">RenderTarget</a>* primary) = 0;
<a name="l01558"></a>01558 
<a name="l01559"></a>01559 
<a name="l01560"></a><a class="code" href="classOgre_1_1RenderSystem.html#a2a2b64fcb748ff0bd21231c23ad3fe98">01560</a>         <a class="code" href="structOgre_1_1DriverVersion.html" title="DriverVersion is used by RenderSystemCapabilities and both GL and D3D9 to store the version of the cu...">DriverVersion</a> <a class="code" href="classOgre_1_1RenderSystem.html#a2a2b64fcb748ff0bd21231c23ad3fe98">mDriverVersion</a>;
<a name="l01561"></a>01561 
<a name="l01562"></a><a class="code" href="classOgre_1_1RenderSystem.html#a7d062673a4505cc47867677fdb83e455">01562</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1RenderSystem.html#a7d062673a4505cc47867677fdb83e455">mTexProjRelative</a>;
<a name="l01563"></a><a class="code" href="classOgre_1_1RenderSystem.html#a8b5ae0207f8d1faf47169be4a2ee2714">01563</a>         <a class="code" href="classOgre_1_1Vector3.html" title="Standard 3-dimensional vector.">Vector3</a> <a class="code" href="classOgre_1_1RenderSystem.html#a8b5ae0207f8d1faf47169be4a2ee2714">mTexProjRelativeOrigin</a>;
<a name="l01564"></a>01564 
<a name="l01565"></a>01565 
<a name="l01566"></a>01566 
<a name="l01567"></a>01567     };
<a name="l01570"></a>01570 }
<a name="l01571"></a>01571 
<a name="l01572"></a>01572 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
